using System;
using System.Collections;
using System.Text;

namespace A_Interfaces
{
    class Interfaces
    {
        static void Main(string[] args)
        {
            Dog Pluto = new Dog();
            ElicitSound(Pluto);
            ObjectHolder oh = new ObjectHolder("abc", 1, "ccc");
            ElicitSound(oh);
            foreach (object o in oh) {
                Console.WriteLine(o.ToString());
            }
            Console.ReadLine();
            
        }
        public interface IMakesSounds {
            string MakeSound();
        }
        public static void ElicitSound(IMakesSounds SoundMaker){
            Console.WriteLine("This object makes the following sound: "+SoundMaker.MakeSound());
        }
        public class Dog:IMakesSounds {
            public string MakeSound(){
                return "Bark";
            }
        }
        public class ObjectHolder:IMakesSounds,IEnumerable { 
            internal object[] objectsheld = new object[3];
            public ObjectHolder(object first, object second, object third){
                objectsheld[0] = first;
                objectsheld[1] = second;
                objectsheld[2] = third;
            }
            public string MakeSound() {
                return "Boing";
            }
            public IEnumerator GetEnumerator() {
                return new ObjectHolderEnumerator(this);
            }
        }
        public class ObjectHolderEnumerator: IEnumerator {
            private readonly ObjectHolder oh;
            private int crt;
            public ObjectHolderEnumerator(ObjectHolder oh) {
                this.oh = oh;
                crt = -1;
            }
            public object Current {
                get { return oh.objectsheld[crt]; }
                // This will display objects in reverse order
                //get { return oh.objectsheld[2-crt]; } 
            }
            public bool MoveNext() {
                crt++;
                if (crt < 3) {
                    return true;
                } else {
                    return false;
                }
            }
            public void Reset() {
                crt = 0;
            }
        }
    }
}
