using System;
using System.Collections.Generic;
using System.Text;

namespace B_Exceptions
{
    class Exceptions
 	{
		class SpecializedException : Exception
		{
			public int Value = 0;

			public SpecializedException(string message, int v)
				: base(message)
			{
				Value = v;
			}
		}

		static void Main(string[] args)
		{
			try
			{
                ExceptionThrower(0);
				ExceptionThrower(1); // Remove this line to see a generic exception
				ExceptionThrower(2); // Remove both lines to get no exceptions
			}
			catch (SpecializedException ex)
			{
				Console.WriteLine("Specialized exception caught.");
				Console.WriteLine("Message: " + ex.Message);
				Console.WriteLine("Special value: " + ex.Value);
                // throw; // This will cause an uncaught exception
			}
			catch (Exception ex)
			{
				Console.WriteLine("Generic exception caught.");
				Console.WriteLine("Message: " + ex.Message);
			}
			finally
			{
				Console.WriteLine("Finally block executing.");
			}
			Console.ReadLine();
		}

		static void ExceptionThrower(int i)
		{
			switch (i)
			{
				case 0:
					return;

				case 1:
					throw new SpecializedException("Specialized message here", 21);

				case 2:
					throw new Exception("Generic exception message here.");
			}
		}

		static void OldWay()
		{
			bool NoErrorOccurred = true;

            // Do some work
			if (NoErrorOccurred)
			{
                // Do some work
				if (NoErrorOccurred)
				{
                    // Do some work
					if (NoErrorOccurred)
					{
                        // Do some work
						if (NoErrorOccurred)
						{
						}
						else
						{
							// handle error
						}
					}
					else
					{
						// handle error
					}
				}
				else
				{
					// handle error
				}
			}
			else
			{
				// handle error
			}
		}
    }
}
