using System;
using System.Collections.Generic;
using System.Text;

namespace C_OperatorOverloading
{
    class OperatorOverloading
    {
        static void Main(string[] args)
        {
            Point p0 = new Point();
            Point p1 = new Point(-.9f, 1.2f, 0.0f);

            Console.WriteLine("p0 is: " + p0);
            p0[2] = -2.0f;
            Console.WriteLine("p0 is: " + p0);
            p0 = p0 + p1;
            Console.WriteLine("p0 is: " + p0);
            Console.WriteLine("Projection on x axis for p0 is: " + p0[0]);
            Console.WriteLine("Projection on y axis for p0 is: " + p0[1]);
            Console.WriteLine("Projection on z axis for p0 is: " + p0[2]);
            Console.WriteLine("Distance from p0 to p1 is: " + (p0 ^ p1));
            Console.WriteLine("Distance from origin to p0 is: " + p0["distance to origin"]);
            Console.WriteLine("Distance from x axis to p0 is: " + p0["distance to x axis"]);
            Console.WriteLine("Distance from y axis to p0 is: " + p0["distance to y axis"]);
            Console.WriteLine("Distance from z axis to p0 is: " + p0["distance to z axis"]);
            Console.ReadLine();
        }
    }
    class Point
    {
        public float x, y, z;

        public Point()
        {
            x = y = z = 0.0f;
        }

        public Point(float x, float y, float z)
        {
            this.x = x;
            this.y = y;
            this.z = z;
        }

        public override string ToString()
        {
            return "[" + x + ", " + y + ", " + z + "]";
        }

        public static float operator ^(Point p0, Point p1)
        {
            Point t = p0 - p1;
            return t["distance to origin"];
        }

        public static Point operator +(Point p0, Point p1)
        {
            Point r = new Point();
            r.x = p0.x + p1.x;
            r.y = p0.y + p1.y;
            r.z = p0.z + p1.z;
            return r;
        }

        public static Point operator -(Point p0, Point p1)
        {
            Point r = new Point();
            r.x = p0.x - p1.x;
            r.y = p0.y - p1.y;
            r.z = p0.z - p1.z;
            return r;
        }

        public float this[int index]
        {
            get
            {
                switch (index)
                {
                    case 0:
                        return x;

                    case 1:
                        return y;

                    case 2:
                        return z;

                    default:
                        throw new ArgumentException();
                }
            }
            set
            {
                switch (index)
                {
                    case 0:
                        x = value;
                        break;

                    case 1:
                        y = value;
                        break;

                    case 2:
                        z = value;
                        break;

                    default:
                        throw new ArgumentException();
                }
            }
        }

        public float this[string index]
        {
            get
            {
                switch (index)
                {
                    case "distance to origin":
                        return System.Convert.ToSingle(Math.Sqrt(x * x + y * y + z * z));
                    case "distance to x axis":
                        return System.Convert.ToSingle(Math.Sqrt(y * y + z * z));
                    case "distance to y axis":
                        return System.Convert.ToSingle(Math.Sqrt(x * x + z * z));
                    case "distance to z axis":
                        return System.Convert.ToSingle(Math.Sqrt(x * x + y * y));
                    default:
                        throw new ArgumentException();
                }
            }
        }
    }
}
