using System;
using System.Collections.Generic;
using System.Text;

namespace D_Delegates
{
    class Delegates
    {
        static void Main(string[] args)
        {
            DemonstrateFunction(Math.Log10, "log base 10", 100);
            DemonstrateFunction(Math.Sqrt, "square root", 100);
            DemonstrateFunction(TaxesOwed, "taxes owed (in thousands)", 100);
            DemonstrateFunction(SocialSecurityTaxesOwed, "SS taxes owed (in thousands)", 100);
            // Below is an example of "multicasting" to multiple delegates
            NumericFunction f = new NumericFunction(SocialSecurityTaxesOwed);
            NumericFunction g = new NumericFunction(TaxesOwed);
            f = f + g;
            DemonstrateFunction(f, "combined", 100);
            f -= g;
            DemonstrateFunction(f, "un-combined", 100);
            f -= g; // Has no effect
            DemonstrateFunction(f, "un-un-combined", 100);
            Console.ReadLine();
        }
        public delegate double NumericFunction(double d);
        public static void DemonstrateFunction(NumericFunction n, string name, double d) {
            Console.WriteLine("Function " + name + " applied to " + d + " gives result " + n(d));
        }
        public static double TaxesOwed(double income)
        {
            Console.WriteLine("  Computing taxes owed on " + income + " thousands");
            if (income < 30)
            {
                return 0;
            }
            else if (income < 60)
            {
                return (income - 30) * 0.2;
            }
            else
            {
                return 30 * 0.2 + (income - 60) * 0.4;
            }
        }
        public static double SocialSecurityTaxesOwed(double income)
        {
            Console.WriteLine("  Computing social security taxes owed on " + income + " thousands");
            return income * 0.03;
        }
    }
}
